#ifndef UNCONFIGURED_SYMBOLS_H
#define UNCONFIGURED_SYMBOLS_H

/***************************************************************************
 *   Copyright (C) 2007-2010 Mike Kinghan, imk@strudl.org            *
 *   All rights reserved.                                                  *
 *                                                                         *
 *   Contributed originally by Mike Kinghan, imk@strudl.org                *
 *                                                                         *
 *   Redistribution and use in source and binary forms, with or without    *
 *   modification, are permitted provided that the following conditions    *
 *   are met:                                                              *
 *                                                                         *
 *   Redistributions of source code must retain the above copyright        *
 *   notice, this list of conditions and the following disclaimer.         *
 *                                                                         *
 *   Redistributions in binary form must reproduce the above copyright     *
 *   notice, this list of conditions and the following disclaimer in the   *
 *   documentation and/or other materials provided with the distribution.  *
 *                                                                         *
 *   Neither the name of Symbian Software Ltd. nor the names of its        *
 *   contributors may be used to endorse or promote products derived from  *
 *   this software without specific prior written permission.              *
 *                                                                         *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   *
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     *
 *   LIMITED TO, THE IMPLIED WARRANTIES OF  MERCHANTABILITY AND FITNESS    *
 *   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE        *
 *   COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,   *
 *   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,  *
 *   BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS *
 *   OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED    *
 *   AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,*
 *   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF *
 *   THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  *
 *   DAMAGE.                                                               *
 *                                                                         *
 **************************************************************************/

#include "state_utils.h"
#include "ptr_set.h"
#include "symbol.h"

/*!\ingroup unconfigured_symbols_interface unconfigured_symbols_interface
 *\file unconfigured_symbols.h
 * This file provides the Configured Symbols component interface
*/

/*!\addtogroup unconfigured_symbols_interface*/
/*@{*/

/*!	Tally an occurrence of an unconfigured symbol.
	\param	name The name of the symbol

	If no symbol with the given name is in the unconfigured symbols
	table then it is added to the table.

	The occurrence of the symbol is reported on stdout if the
	symbol has not already been seen or if \c --once is not in
	effect.
*/
extern void
unconfigured_symbol_tally(canonical_string_const_h name);

/*@}*/

/*!\ingroup unconfigured_symbols_interface_state_utils*/
/*@{*/
/*! The public state of the Configured Symbols component*/
PUBLIC_STATE_DEF(unconfigured_symbols)
{
    ptr_set_h sym_tab;
    /*!< Handle to the Configured Symbols table*/
}
PUBLIC_STATE_T(unconfigured_symbols);
/*@}*/

/*!\addtogroup unconfigured_symbols_interface_state_utils*/
/*@{*/
IMPORT(unconfigured_symbols);
/*@}*/


#endif /* EOF*/
